#include "SPI.h"
#include <EEPROM.h>
word outputValue = 0; // word = 16 bits
word outputValueRES = 0; 
byte data = 0;
int a;
int res = 0;
#include <MIDI.h>
MIDI_CREATE_DEFAULT_INSTANCE();
byte pad[50] = {0, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84}; // Rien + 49 NOTES
short pats[128];
short pots[130];            // == steps MAX +1
short sMax = 129; 			// nombre max de steps (2, 129) == 128 steps
short steps = 9;			// reel step number == steps -1
const byte  buttonRDM = 2;  // Random (gate input)
const byte  buttonRST = 3; 	// Reset (btn + gate input)
const byte  buttonREC = 4;  // REC btn only
const byte  buttonYALP = 8; // YALP (btn + switch play) 
const byte  buttonPLAY = 9; // PLAY (btn + gate input)
const byte LED = 15;      	// rec & notes led 
const byte LED2 = 12;     	// offbeat led 
const byte lCy = 14;     	// cycle led
const byte Gon = 5;         //  gate note on output
const byte Goff = 6;        // gate note off output
const byte Gcy = 7;         // gate cycle output
const byte buttonPin = 16; //button channel select
const byte cled = 17; // blinking channel led
byte chn; // midi channel
int address = 1; // memmory channel
boolean butChn; // button channel
boolean buttonStateREC = 0; 
boolean lastButtonStateREC = 0; 
boolean buttonStateRST = 0; 
boolean lastButtonStateRST= 0; 
boolean buttonStatePLAY = 0;
boolean lastButtonStatePLAY = 0;   
boolean buttonStateYALP = 0;
boolean lastButtonStateYALP = 0;
boolean buttonStateRDM = 0;
boolean lastButtonStateRDM = 0;
byte  state = 1; 
byte recDly = 200;
byte playDly = 10;
byte resMid = 0;

void setup()
{
	pinMode(10, OUTPUT); 		//ard_Pin_10 --> dacPin_2 SC verrou du DAC
	SPI.begin(); 				//démarrage de la liaison SPI
	SPI.setBitOrder(MSBFIRST);  //ard_Pin-13 --> dacPin_3
								//ard_Pin-11 --> dacPin_4
	pinMode(buttonREC, INPUT_PULLUP);
	pinMode(buttonRST, INPUT_PULLUP);
	pinMode(buttonPLAY, INPUT_PULLUP);
	pinMode(buttonYALP, INPUT_PULLUP);
	pinMode(buttonRDM, INPUT_PULLUP);
	digitalWrite(LED,LOW);
	digitalWrite(LED2,LOW);
	digitalWrite(lCy,LOW);
	digitalWrite(Gon,LOW);
	digitalWrite(Goff,LOW);
	digitalWrite(Gcy,LOW);
	pinMode(cled, OUTPUT);
	pinMode(buttonPin, INPUT_PULLUP);
  chn = EEPROM.read(address);
	delay (100);

if (chn == 0 || chn > 16)
{
chn = 1;
EEPROM.write(address, chn);
delay(1000);
MIDI.begin(chn);
start (chn);
}
else
{
delay(1000);
MIDI.begin(chn);
bar (chn);
}  
}
void dac(int a)

{
outputValue = a;
digitalWrite(10, LOW);
data = highByte(outputValue); //on enverra les données en 2 octets : selection du premier octet
data = 0b00001111 & data;
data = 0b00010000 | data; //on ajoute les paramètres du DAC à envoyer
SPI.transfer(data);
data = lowByte(outputValue);
SPI.transfer(data); //deuxième octet
digitalWrite(10, HIGH);
}

void doc(int res)
{
outputValueRES = res;
digitalWrite(10, LOW);
data = highByte(outputValueRES);
data = 0b00001111 & data;
data = 0b00010000 | data;
SPI.transfer(data);
data = lowByte(outputValueRES);
SPI.transfer(data);
digitalWrite(10, HIGH);
}
void start(byte chn)
{
    for (byte i=0; i<chn; i++) 
    {
    digitalWrite(cled, HIGH);
    delay(50);
    digitalWrite(cled, LOW);
    delay(400);
    loop();
    }
}
void bar(byte chn)
{
    for (byte i=0; i<chn; i++) 
    {
    digitalWrite(cled, HIGH);
    delay(50);
    digitalWrite(cled, LOW);
    delay(400);
    }
}

void loop() 
{
	a = map (analogRead(A6), 0 , 1027, 0, 4090);
	byte note = map (analogRead(A6), 0, 1023, 0, 49);
	steps = map(analogRead(A7),0,1023,2,sMax); //steps
	buttonStateREC = digitalRead(buttonREC);
	buttonStateRST = digitalRead(buttonRST);
	buttonStatePLAY = digitalRead(buttonPLAY);
	buttonStateYALP = digitalRead(buttonYALP);
	buttonStateRDM = digitalRead(buttonRDM);
	butChn = digitalRead(buttonPin); // button channnel select
	
	if (butChn == HIGH)
      {
      chn+=1;
      if (chn <= 16)
      {
      EEPROM.write(address, chn);
      delay(500);
      MIDI.begin(chn);
      bar (chn);
      }
      if (chn >= 17)
      {
      chn = 1;
      EEPROM.write(address, chn);
      delay(500);
      MIDI.begin(chn);
      bar(chn);
      }
      }
	
	if (buttonStateRST != lastButtonStateRST) //RST D3
	{
		if (buttonStateRST == LOW)
		{ 
			state = 1; // start cycle
			digitalWrite(lCy,HIGH); 
			digitalWrite(Gcy,HIGH); 
			delay(playDly);
			digitalWrite(lCy,LOW);
			digitalWrite(Gcy,LOW);
		}
	}
	lastButtonStateRST = buttonStateRST; //RST D3
	
	
	if (buttonStateREC == LOW) //REC D4
	{
		pots[state] = a;
		pats[state] = pad[note];
		digitalWrite(LED,HIGH);
		digitalWrite(Gon,HIGH);
		dac(a);
		MIDI.sendNoteOn(pad[note], 127, chn);
		delay(recDly);
		digitalWrite(LED,LOW);
		digitalWrite(Gon,LOW);
		MIDI.sendNoteOff(pad[note], 0, chn);
	}		//REC D4
	
	if (buttonStatePLAY != lastButtonStatePLAY)  //PLAY D9
	{
		if (buttonStatePLAY == LOW && buttonStateREC == HIGH)
		{ 
			if (state < steps)
			{
				state+=1;
				res = pots[state];
				resMid = pats[state];
				
				if (resMid > 0 && state != steps)
				{
					digitalWrite(LED,HIGH);
					digitalWrite(Gon,HIGH);
					doc(res);
					MIDI.sendNoteOn(resMid, 127, chn);
					delay(playDly);
					MIDI.sendNoteOff(resMid, 0, chn);
					digitalWrite(LED,LOW);
					digitalWrite(Gon,LOW);
				}
				else if (resMid == 0 && state != steps)
				{
					digitalWrite(LED2,HIGH);
					digitalWrite(Goff,HIGH);
					MIDI.sendNoteOff(resMid, 0, chn);
					delay(playDly);
					digitalWrite(LED2,LOW);
					digitalWrite(Goff,LOW);
				}
			} 
			if (state == steps || state >= steps) 
			{
				state = 1;
				digitalWrite(lCy,HIGH);
				digitalWrite(Gcy,HIGH);
				res = pots[state];
				resMid = pats[state];
				
				if (resMid > 0)
				{
					digitalWrite(LED,HIGH);
					digitalWrite(Gon,HIGH);
					doc(res);
					MIDI.sendNoteOn(resMid, 127, chn);
					delay(playDly);
					MIDI.sendNoteOff(resMid, 0, chn);
					digitalWrite(LED,LOW);
					digitalWrite(Gon,LOW);
					digitalWrite(lCy,LOW);
					digitalWrite(Gcy,LOW);
					
				}
				else if (resMid ==0)
				{
					digitalWrite(LED2,HIGH);
					digitalWrite(Goff,HIGH);
					MIDI.sendNoteOff(resMid, 0, chn);
					delay(playDly);
					digitalWrite(LED2,LOW);
					digitalWrite(Goff,LOW);
					digitalWrite(Gcy,LOW);
					digitalWrite(lCy,LOW);
				}
			}			
		}
	}
	
	lastButtonStatePLAY = buttonStatePLAY;  //PLAY D9
	
	if (buttonStateYALP != lastButtonStateYALP) //YALP D8
	{
		if (buttonStateYALP == LOW &&  buttonStateREC == HIGH)
		{ 
			if (state > 0 &&  state <= steps)
			{
				
				state-=1;
				res = pots[state];
				resMid = pats[state];
				
				if (resMid > 0 && state !=0 )
				{
					digitalWrite(LED,HIGH);
					digitalWrite(Gon,HIGH);
					doc(res);
					MIDI.sendNoteOn(resMid, 127, chn);
					delay(playDly);
					MIDI.sendNoteOff(resMid, 0, chn);
					digitalWrite(LED,LOW);
					digitalWrite(Gon,LOW);
				}
				else if (resMid == 0 && state !=0) 
				{
					digitalWrite(LED2,HIGH);
					digitalWrite(Goff,HIGH);
					MIDI.sendNoteOff(resMid, 0, chn);
					delay(playDly);
					digitalWrite(LED2,LOW);
					digitalWrite(Goff,LOW);
				}
			}
			
			if (state == 0 || state > steps)
			{
				state = steps-1;
				res = pots[state];
				resMid = pats[state];
				digitalWrite(lCy,HIGH);
				digitalWrite(Gcy,HIGH);
				
				if (resMid > 0 && state ==steps-1)
				{
					digitalWrite(LED,HIGH);
					digitalWrite(Gon,HIGH);
					doc(res);
					MIDI.sendNoteOn(resMid, 127, chn);
					delay(playDly);
					MIDI.sendNoteOff(resMid, 0, chn);
					digitalWrite(LED,LOW);
					digitalWrite(Gon,LOW);
					digitalWrite(lCy,LOW);
					digitalWrite(Gcy,LOW);
				}
				else if (resMid == 0 && state ==steps-1) 
				{
					digitalWrite(LED2,HIGH);
					digitalWrite(Goff,HIGH);
					MIDI.sendNoteOff(resMid, 0, chn);
					delay(playDly);
					digitalWrite(LED2,LOW);
					digitalWrite(Goff,LOW);
					digitalWrite(lCy,LOW);
					digitalWrite(Gcy,LOW);
				}
			}
		}
	}
	lastButtonStateYALP = buttonStateYALP; //YALP D8
	
	if (buttonStateRDM != lastButtonStateRDM) //RDM D2
	{
		if (buttonStateRDM == LOW && buttonStateREC == HIGH)
		{ 
			state = random (1, steps);
			res = pots[state];
			resMid = pats[state];
			
			if (resMid > 0)
			{
				digitalWrite(LED,HIGH);
				digitalWrite(Gon,HIGH);
				doc(res);
				MIDI.sendNoteOn(resMid, 127, chn);
				delay(playDly);
				digitalWrite(LED,LOW);
				digitalWrite(Gon,LOW);
				MIDI.sendNoteOff(resMid, 0, chn);
			}
			else if (resMid == 0)
			{
				digitalWrite(LED2,HIGH);
				digitalWrite(Goff,HIGH);
				MIDI.sendNoteOff(resMid, 0, chn);
				delay(playDly);
				digitalWrite(LED2,LOW);
				digitalWrite(Goff,LOW);
				
			}
		}
	}
	lastButtonStateRDM = buttonStateRDM; //RDM D2
}
